package cn.efunbox.audio.controller;

import cn.efunbox.audio.entity.Record;
import cn.efunbox.audio.service.RecordService;
import cn.efunbox.audio.utils.ApiCode;
import cn.efunbox.audio.utils.HttpUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 音频点播记录
 * Created by yao on 17-9-26.
 */
@RestController
@Slf4j
@RequestMapping(value = "/record")
public class RecordController {

    @Autowired
    RecordService recordService;

    @RequestMapping(value = "/search" ,method = RequestMethod.POST)
    public void Search(HttpServletRequest request, HttpServletResponse response){
        String idRecord = request.getParameter("idRecord");
        String idChannel = request.getParameter("idChannel");
        String idDevice = request.getParameter("idDevice");
        String idAudio = request.getParameter("idAudio");
        String page = request.getParameter("page");
        String size = request.getParameter("size");
        if(page==null || page.length()<1)
            page = "0";
        if(size==null || size.length()<1)
            size = "0";
//        if(idRecord==null && idChannel==null && idDevice==null && idAudio==null){
//            HttpUtil.responseApiCode(request, response, ApiCode.PARAMETER_ERROR);
//            return;
//        }
        Map<String,Object> map = new HashMap<>();
        Page<Record> pageRes = null;
        List<Record> list = null;
        if(idRecord!=null && idRecord.length()>0)
            list = recordService.SearchById(Long.valueOf(idRecord));
        else if(idChannel!=null && idChannel.length()>0)
            pageRes = recordService.SearchByIdChannel(Long.valueOf(idChannel), Integer.valueOf(page), Integer.valueOf(size));
        else if(idDevice!=null && idDevice.length()>0)
            pageRes = recordService.SearchByIdDevice(Long.valueOf(idDevice), Integer.valueOf(page), Integer.valueOf(size));
        else if(idAudio!=null && idAudio.length()>0)
            pageRes = recordService.SearchByIdAudio(Long.valueOf(idAudio), Integer.valueOf(page), Integer.valueOf(size));
        else
            pageRes = recordService.SearchAll(Integer.valueOf(page), Integer.valueOf(size));

//        if(list==null || list.size()<1){
//            HttpUtil.responseApiCode(request, response, ApiCode.NOT_FOUND);
//            return;
//        }

        if(list!=null){
            map.put("data", list);
            map.put("size", list.size());
            map.put("total", list.size());
        }else if(pageRes!=null){
            map.put("data", pageRes.getContent());
            map.put("size", pageRes.getNumberOfElements());
            map.put("total", pageRes.getTotalElements());
        }

        HttpUtil.responseOkData(request, response, map);
        return;
    }

}
