package cn.efunbox.audio.entity;


import cn.efunbox.audio.consts.Status;
import lombok.Data;
import lombok.ToString;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.io.Serializable;
import java.sql.Timestamp;
import java.util.Date;

/**
 * 渠道对资源组的权限
 * Created by yao on 17-9-26.
 */


@Data
@ToString
@Entity
@DynamicInsert
@DynamicUpdate
public class Rights implements Serializable, Cloneable {

    @Id
    @GeneratedValue
    private Long id;

    //渠道编号
    @Column
    private Long idChannel;

    //渠道名称
    @Column
    private String nameChannel;

    //资源组编号
    @Column
    private Long idGroup;

    //资源组名称
    @Column
    private String nameGroup;

    @Column
    private Integer status;

    @Column
//    @Temporal(TemporalType.TIMESTAMP)
//    private Date created;
    private Timestamp created;

    public Object clone() throws CloneNotSupportedException {
        return super.clone();
    }


}
